<?php
if($data['id']!=User::a()->user['id']){
	header("Location:/Lunapark/");
	die();
	}
	
$prepare = DB::a()->d->prepare("SELECT * FROM `gallery` WHERE user=:id");
$prepare->bindParam(':id', $data['id'] ,PDO::PARAM_INT);		
$prepare->execute();
$fotos = $prepare->fetchAll();	
	
function img_resize($src, $dest, $width, $height, $rgb = 0xFFFFFF, $quality = 100)
{  
    if (!file_exists($src))
        return false;
 
    $size = getimagesize($src);
      
    if ($size === false)
        return false;
 
    $format = strtolower(substr($size['mime'], strpos($size['mime'], '/') + 1));
    $icfunc = 'imagecreatefrom'.$format;
     
    if (!function_exists($icfunc))
        return false;
 
    $x_ratio = $width  / $size[0];
    $y_ratio = $height / $size[1];
     
    if ($height == 0)
    { 
        $y_ratio = $x_ratio;
        $height  = $y_ratio * $size[1];
    }
    elseif ($width == 0)
    { 
        $x_ratio = $y_ratio;
        $width   = $x_ratio * $size[0];
    }
     
    $ratio       = min($x_ratio, $y_ratio);
    $use_x_ratio = ($x_ratio == $ratio);
     
    $new_width   = $use_x_ratio  ? $width  : floor($size[0] * $ratio);
    $new_height  = !$use_x_ratio ? $height : floor($size[1] * $ratio);
    $new_left    = $use_x_ratio  ? 0 : floor(($width - $new_width)   / 2);
    $new_top     = !$use_x_ratio ? 0 : floor(($height - $new_height) / 2);
      
    // если не нужно увеличивать маленькую картинку до указанного размера
    if ($size[0]<$new_width && $size[1]<$new_height)
    {
        $width = $new_width = $size[0];
        $height = $new_height = $size[1];
    }
 
    $isrc  = $icfunc($src);
    $idest = imagecreatetruecolor($width, $height);
      
    imagefill($idest, 0, 0, $rgb);
    imagecopyresampled($idest, $isrc, $new_left, $new_top, 0, 0, $new_width, $new_height, $size[0], $size[1]);
 
    $i = strrpos($dest,'.');
    if (!$i) return '';
    $l = strlen($dest) - $i;
    $ext = substr($dest,$i+1,$l);
     
    switch ($ext)
    {
        case 'jpeg':
        case 'jpg':
        imagejpeg($idest,$dest,$quality);
        break;
        case 'gif':
        imagegif($idest,$dest);
        break;
        case 'png':
        imagepng($idest,$dest);
        break;
    }
 
    imagedestroy($isrc);
    imagedestroy($idest);
 
    return true;  
}	
	
	
$blacklist = array(".php", ".phtml", ".php3", ".php4");

	if(isset($_POST['upload'])){

			foreach ($blacklist as $item) {
			  if(preg_match("/$item\$/i", $_FILES['userfile']['name'])) {
			   	$_SESSION['info'] = "Запрещенный формат файла!";
				header('Location:/User/'.$data['id'].'/Upload/');
				die();
			   }
			  }
			  
		 $imageinfo = getimagesize($_FILES['userfile']['tmp_name']);
			 if($imageinfo['mime'] != 'image/gif' && $imageinfo['mime'] != 'image/jpeg' && $imageinfo['mime'] != 'image/png') {
			   	$_SESSION['info'] = "Разрешается загружать фото в формате PNG,JPG,GIF!";
				header('Location:/User/'.$data['id'].'/Upload/');
				die();
			 }

			$uploaddir = 'gallery/'.User::a()->user['id'].'/';
			$uploadfile = $uploaddir.md5(md5(time())).'.jpeg';
			$uploadfile2 = $uploaddir.md5(md5(time())).'_mini.jpeg';
			$name = md5(md5(time()));
			
			if(!file_exists($uploaddir))
				{
				@mkdir($uploaddir, 0777);
				}
		
		  @chmod('/gallery/'.User::a()->user['id'].'/', 0777);
		  if (move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)) {
			  if(!img_resize($uploadfile, $uploadfile2 ,120,120,'0x2d683c')){
				$_SESSION['info'] = "Ошибка создания копии!";
				header('Location:/User/'.$data['id'].'/Upload/');
				die();				  
			  }
			
			$isRating = 0;
			if(isset($_POST['rating']) && $_POST['rating']==1)$isRating = 1;	
			$ins = DB::a()->d->query("INSERT INTO `gallery` (`user`,`time`,`link`,`rating`) VALUES ('".User::a()->user['id']."', '".time()."','".$name."','".$isRating."')");
			$_SESSION['info'] = "Фото успешно загружено!";
				header('Location:/User/'.$data['id'].'/Gallery/');
				die();
				}

				$_SESSION['info'] = "Ошибка загрузки фото!";
				header('Location:/User/'.$data['id'].'/Upload/');
				die();			

	}
	
	
Template::a()->setTitle('Загрузка фото');
Template::a()->set('fotos',$fotos);
Template::a()->display('user/upload');	