-- phpMyAdmin SQL Dump
-- version 4.0.10.10
-- http://www.phpmyadmin.net
--
-- Хост: 127.0.0.1:3306
-- Время создания: Май 07 2018 г., 14:25
-- Версия сервера: 5.5.45
-- Версия PHP: 5.5.28

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- База данных: `lp`
--

-- --------------------------------------------------------

--
-- Структура таблицы `cards`
--

CREATE TABLE IF NOT EXISTS `cards` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `amount` bigint(50) NOT NULL DEFAULT '0',
  `number` varchar(15) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `type` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `number` (`number`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `chat`
--

CREATE TABLE IF NOT EXISTS `chat` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `text` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `Company`
--

CREATE TABLE IF NOT EXISTS `Company` (
  `cid` int(11) NOT NULL AUTO_INCREMENT,
  `companyName` varchar(100) NOT NULL,
  `companyDate` int(11) NOT NULL,
  `companyCreater` int(11) NOT NULL,
  `companyRating` bigint(50) NOT NULL DEFAULT '0',
  `companyTender` int(11) NOT NULL DEFAULT '0',
  `companyLevel` int(3) NOT NULL DEFAULT '1',
  `companyMoney` bigint(50) unsigned NOT NULL,
  `companyDonate` bigint(50) unsigned NOT NULL,
  `companyStatus` varchar(100) NOT NULL DEFAULT 'Компания успешно создана!',
  `companyStatusCreater` int(11) NOT NULL,
  `companyStatusTime` int(11) NOT NULL DEFAULT '0',
  `companyMaxUsers` int(6) NOT NULL DEFAULT '10',
  `companyUsers` text NOT NULL,
  `companyChat` int(11) NOT NULL DEFAULT '0',
  `companyExchange` int(3) NOT NULL DEFAULT '0',
  `companyExchangeTime` int(11) NOT NULL DEFAULT '0',
  `DocLunapark` int(2) unsigned NOT NULL DEFAULT '0',
  `DocTrade` int(2) unsigned NOT NULL DEFAULT '0',
  `DocTradeTime` int(2) unsigned NOT NULL DEFAULT '0',
  `DocTender` int(2) unsigned NOT NULL DEFAULT '0',
  `DocTenderRating` int(2) unsigned NOT NULL DEFAULT '0',
  `DocShop` int(2) unsigned NOT NULL DEFAULT '0',
  `DocWorkers` int(2) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`),
  KEY `companyRating` (`companyRating`),
  KEY `companyTender` (`companyTender`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `CompanyChat`
--

CREATE TABLE IF NOT EXISTS `CompanyChat` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `company` int(5) NOT NULL DEFAULT '1',
  `user` int(11) NOT NULL,
  `text` text NOT NULL,
  `time` int(11) NOT NULL,
  `del` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `company` (`company`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `CompanyHistory`
--

CREATE TABLE IF NOT EXISTS `CompanyHistory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `company` int(11) NOT NULL,
  `text` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `company` (`company`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `forumMessage`
--

CREATE TABLE IF NOT EXISTS `forumMessage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `forum` int(2) NOT NULL,
  `topic` int(5) NOT NULL,
  `user` int(11) NOT NULL,
  `message` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `forum` (`forum`,`topic`,`time`),
  KEY `topic` (`topic`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `forums`
--

CREATE TABLE IF NOT EXISTS `forums` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `admin` int(2) NOT NULL DEFAULT '0',
  `newTop` tinyint(1) NOT NULL DEFAULT '0',
  `users` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `forumTopics`
--

CREATE TABLE IF NOT EXISTS `forumTopics` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `forum` tinyint(2) NOT NULL DEFAULT '1',
  `user` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `lastMessage` int(11) NOT NULL,
  `users` text NOT NULL,
  `imp` tinyint(1) NOT NULL DEFAULT '0',
  `closed` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `forum` (`forum`),
  KEY `lastMessage` (`lastMessage`),
  KEY `imp` (`imp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `gallery`
--

CREATE TABLE IF NOT EXISTS `gallery` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `link` varchar(32) NOT NULL,
  `likes` int(11) NOT NULL DEFAULT '0',
  `who` text NOT NULL,
  `rating` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `user` (`user`,`time`,`link`),
  KEY `rating` (`rating`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `gifts`
--

CREATE TABLE IF NOT EXISTS `gifts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) unsigned NOT NULL,
  `who` int(11) unsigned NOT NULL,
  `time` int(11) unsigned NOT NULL,
  `text` text NOT NULL,
  `idGift` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `pays`
--

CREATE TABLE IF NOT EXISTS `pays` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` bigint(20) unsigned NOT NULL,
  `time` bigint(20) unsigned NOT NULL,
  `sum` int(10) unsigned NOT NULL,
  `success` tinyint(1) unsigned NOT NULL,
  `system` varchar(255) NOT NULL,
  `dop` text NOT NULL,
  `cancel` tinyint(1) NOT NULL,
  `special` tinyint(1) unsigned NOT NULL,
  `request` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `race`
--

CREATE TABLE IF NOT EXISTS `race` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `time` int(11) NOT NULL,
  `data` text NOT NULL,
  `money` bigint(50) NOT NULL DEFAULT '20000',
  `user1` int(11) NOT NULL,
  `user2` int(11) NOT NULL,
  `user3` int(11) NOT NULL,
  `user4` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `user1` (`user1`,`user2`,`user3`,`user4`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `raceInvite`
--

CREATE TABLE IF NOT EXISTS `raceInvite` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `level` int(3) NOT NULL,
  `car` int(2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `car` (`car`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `setting`
--

CREATE TABLE IF NOT EXISTS `setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `count_online` int(11) unsigned NOT NULL,
  `count_users` int(11) unsigned NOT NULL,
  `count_chat` int(11) NOT NULL DEFAULT '0',
  `action` int(2) unsigned NOT NULL,
  `actionTime` int(11) NOT NULL DEFAULT '0',
  `idTender` tinyint(2) NOT NULL DEFAULT '0',
  `timeTender` int(11) NOT NULL DEFAULT '0',
  `countTopics` int(11) NOT NULL DEFAULT '0',
  `countMessage` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Дамп данных таблицы `setting`
--

INSERT INTO `setting` (`id`, `count_online`, `count_users`, `count_chat`, `action`, `actionTime`, `idTender`, `timeTender`, `countTopics`, `countMessage`) VALUES
(1, 0, 0, 0, 2, 0, 0, 0, 0, 0);

-- --------------------------------------------------------

--
-- Структура таблицы `support`
--

CREATE TABLE IF NOT EXISTS `support` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `type` int(1) NOT NULL DEFAULT '1',
  `text` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`type`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nick` varchar(100) NOT NULL,
  `password` varchar(32) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `ip` varchar(200) NOT NULL,
  `browser` varchar(500) NOT NULL,
  `email` varchar(100) NOT NULL DEFAULT '0',
  `date_reg` int(10) unsigned NOT NULL,
  `date_last` int(10) unsigned NOT NULL,
  `userInfo` text NOT NULL,
  `in_game` int(11) NOT NULL DEFAULT '0',
  `money` varchar(50) NOT NULL DEFAULT '5000',
  `lov` bigint(50) NOT NULL DEFAULT '0',
  `donate` int(11) NOT NULL DEFAULT '20',
  `doubleDay` varchar(20) NOT NULL,
  `hash` varchar(32) NOT NULL,
  `level` tinyint(11) NOT NULL DEFAULT '1',
  `rating` varchar(50) NOT NULL DEFAULT '0',
  `sex` tinyint(1) NOT NULL DEFAULT '0',
  `dataPark` text NOT NULL,
  `dataShapito` text NOT NULL,
  `cityShapito` int(11) NOT NULL DEFAULT '1',
  `cityTime` int(11) NOT NULL DEFAULT '0',
  `dataJobs` text NOT NULL,
  `dataTender` text NOT NULL,
  `thisTender` int(2) unsigned NOT NULL DEFAULT '0',
  `dataTrade` text NOT NULL,
  `dataShop` text NOT NULL,
  `dataWorkers` text NOT NULL,
  `dataDost` text NOT NULL,
  `counts` text NOT NULL,
  `IdCompany` int(5) NOT NULL DEFAULT '0',
  `LevelCompany` int(1) NOT NULL DEFAULT '0',
  `getCompany` varchar(100) NOT NULL DEFAULT '0',
  `cRating` int(11) NOT NULL DEFAULT '0',
  `cTime` int(11) NOT NULL DEFAULT '0',
  `cRatingWeek` int(11) NOT NULL DEFAULT '0',
  `cRatingTender` int(11) NOT NULL DEFAULT '0',
  `cMoney` bigint(50) NOT NULL DEFAULT '0',
  `cDonate` int(11) NOT NULL DEFAULT '0',
  `cChatCount` int(11) NOT NULL DEFAULT '0',
  `tRating` decimal(30,10) unsigned NOT NULL DEFAULT '0.0000000000',
  `tLove` bigint(50) NOT NULL DEFAULT '0',
  `tCircus` bigint(50) NOT NULL DEFAULT '0',
  `rCircus` bigint(50) NOT NULL DEFAULT '0',
  `rLove` bigint(50) NOT NULL DEFAULT '0',
  `tMoney` bigint(20) unsigned NOT NULL DEFAULT '0',
  `tTrade` int(11) unsigned NOT NULL DEFAULT '0',
  `tRace` int(11) unsigned NOT NULL DEFAULT '0',
  `tOnline` int(11) unsigned NOT NULL DEFAULT '0',
  `tPresent` int(11) unsigned NOT NULL DEFAULT '0',
  `tTender` int(11) unsigned NOT NULL DEFAULT '0',
  `tLottery` int(11) NOT NULL DEFAULT '0',
  `tradeMas` int(11) NOT NULL DEFAULT '0',
  `racerMas` int(11) NOT NULL DEFAULT '0',
  `countDost` int(11) NOT NULL DEFAULT '0',
  `raceWin` int(11) NOT NULL DEFAULT '0',
  `countJobs` int(11) unsigned NOT NULL,
  `countTech` int(3) unsigned NOT NULL,
  `chatDost` int(1) NOT NULL DEFAULT '0' COMMENT '0-Работает достижение Чат,1-Нет',
  `mail` int(11) unsigned NOT NULL,
  `PaysSum` int(11) NOT NULL DEFAULT '0',
  `PaysCount` int(11) NOT NULL DEFAULT '0',
  `actionStatus` int(1) NOT NULL DEFAULT '0',
  `ban` text NOT NULL,
  `car` varchar(255) NOT NULL,
  `race` int(1) NOT NULL DEFAULT '0',
  `odk_id` bigint(20) NOT NULL,
  `odk_time` bigint(20) NOT NULL,
  `odk_session` text NOT NULL,
  `odk_session_secret_key` text NOT NULL,
  `odk_cache` text NOT NULL,
  `countMail` int(11) unsigned NOT NULL DEFAULT '0',
  `bonus` int(11) unsigned NOT NULL DEFAULT '0',
  `friends` text NOT NULL,
  `ignor` text NOT NULL,
  `avatar` varchar(32) NOT NULL DEFAULT '0',
  `present` int(11) unsigned NOT NULL DEFAULT '0',
  `delivery` int(11) unsigned NOT NULL DEFAULT '0',
  `setPresent` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `setMail` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `setCompany` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `loveInvite` int(11) unsigned NOT NULL DEFAULT '0',
  `love` int(11) unsigned NOT NULL DEFAULT '0',
  `appMail` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `appPresent` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `appAuth` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `floodPresent` int(11) NOT NULL DEFAULT '0',
  `raceCount` tinyint(1) NOT NULL DEFAULT '0',
  `lottery` tinyint(2) NOT NULL DEFAULT '1',
  `notes` int(1) NOT NULL DEFAULT '0',
  `ref` int(11) NOT NULL DEFAULT '0',
  `op` int(1) NOT NULL DEFAULT '0',
  `vip` int(1) NOT NULL DEFAULT '0',
  `smiles` text NOT NULL,
  `panel` tinyint(1) NOT NULL DEFAULT '1',
  `card` tinyint(1) NOT NULL DEFAULT '0',
  `referals` int(11) unsigned NOT NULL DEFAULT '0',
  `banCard` tinyint(1) NOT NULL DEFAULT '0',
  `factVred` int(11) NOT NULL DEFAULT '0',
  `maxVred` int(11) NOT NULL DEFAULT '10',
  `turnirVred` int(11) NOT NULL DEFAULT '0',
  `jurnal` int(11) unsigned NOT NULL DEFAULT '0',
  `ratingVred` bigint(30) unsigned NOT NULL DEFAULT '0',
  `vnim` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `in_game` (`in_game`),
  KEY `rating` (`rating`),
  KEY `countDost` (`countDost`),
  KEY `racerMas` (`racerMas`),
  KEY `tradeMas` (`tradeMas`),
  KEY `raceWin` (`raceWin`),
  KEY `nick` (`nick`),
  KEY `password` (`password`),
  KEY `countJobs` (`countJobs`),
  KEY `tRating` (`tRating`),
  KEY `tRace` (`tRace`),
  KEY `tMoney` (`tMoney`),
  KEY `tTrade` (`tTrade`),
  KEY `hash` (`hash`),
  KEY `email` (`email`),
  KEY `odk_id` (`odk_id`),
  KEY `odk_time` (`odk_time`),
  KEY `tOnline` (`tOnline`),
  KEY `tLottery` (`tLottery`),
  KEY `PaysCount` (`PaysCount`),
  KEY `notes` (`notes`),
  KEY `status` (`status`),
  KEY `date_last` (`date_last`),
  KEY `cRatingTender_2` (`cRatingTender`),
  KEY `ref` (`ref`),
  KEY `op` (`op`),
  KEY `vip` (`vip`),
  KEY `level` (`level`),
  KEY `referals` (`referals`),
  KEY `turnirVred` (`turnirVred`),
  KEY `ratingVred` (`ratingVred`),
  KEY `cityShapito` (`cityShapito`),
  KEY `tLove` (`tLove`),
  KEY `tCircus` (`tCircus`),
  KEY `rCircus` (`rCircus`),
  KEY `rLove` (`rLove`),
  KEY `lov` (`lov`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `usersHistory`
--

CREATE TABLE IF NOT EXISTS `usersHistory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `text` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user` (`user`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Структура таблицы `usersWorkers`
--

CREATE TABLE IF NOT EXISTS `usersWorkers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user` int(11) NOT NULL,
  `finansist` int(11) unsigned NOT NULL,
  `reklam` int(11) unsigned NOT NULL DEFAULT '0',
  `mechanic` int(11) unsigned NOT NULL,
  `kassir` int(11) unsigned NOT NULL,
  `oficiant` int(11) unsigned NOT NULL,
  `povar` int(11) unsigned NOT NULL,
  `barmen` int(11) unsigned NOT NULL,
  `smotrit` int(11) NOT NULL DEFAULT '0',
  `uprav` int(11) NOT NULL DEFAULT '0',
  `ohrana` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `reklam` (`reklam`),
  KEY `finansist` (`finansist`),
  KEY `user` (`user`),
  KEY `mechanic` (`mechanic`),
  KEY `kassir` (`kassir`),
  KEY `oficiant` (`oficiant`),
  KEY `povar` (`povar`),
  KEY `barmen` (`barmen`),
  KEY `smotrit` (`smotrit`),
  KEY `uprav` (`uprav`),
  KEY `ohrana` (`ohrana`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
